function [Classe, iter, dif,m]=Func_k_medias(D, c, m)

%Algoritmo do Agrupamento das K-mdias
%Adrielle de Carvalho Santana
%Tcnicas Clssicas de Classificao de Padres
%UFMG - 2015/01
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%D: matriz N X l com as coordenadas dos dados a serem classificados
%c: nmero de classes ou grupos e nmero de centroides
%N: nmero de amostras a serem classificadas
%l: nmero de dimenses dos dados (espera-se 3 nesse algoritmo)
%m: matriz c X l contendo as coordenadas dos 'c' centroides.
%Classe: Matriz c X N, de 0's e 1's, em que cada linha corresponde a uma 
% classe ou grupo e cada coluna corresponde a um dado. H apenas um '1' por
% coluna indicando que o dado pertence  classe daquela linha. 
%Dist: matriz c X N com as distncias Euclidianas de cada amostra at o 
%centroide de cada classe/grupo.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[N,l]=size(D);
[a,b]=size(m);
Classe=[];
Dist=[]; %matriz de distncias
class_temp=[]; %matriz com valor anterior de Classe 
dif= c * N; %quantidade de diferenas da matriz Classe atual com a anterior
       %quando a atual for igual a anterior esse valor ser zero e esse
       % o critrio de parada
maxiter = 10000;
iter = 0;
while ((dif > 0)&&(iter < maxiter))
   dif= c * N;
   iter = iter + 1;
   for i=1:c %mudar esse clculo se se tratar de mais ou menos dimenses do que 3
    for j=1:N
        a1=D(j,1)-m(i,1);
        a2=D(j,2)-m(i,2);
        a3=D(j,3)-m(i,3);
        Dist(i,j)=sqrt((a1^2)+(a2^2)+(a3^2));
    end
   end
%Classificao dos pontos em suas classes/grupos de acordo com a distncia
%Euclidiana calculada do ponto a cada centroide.
%Tambm j  feito o clculo do novo centroide.
if (c==3) %se a quantidade de classes/grupos for 3
cont1=0; %conta quantas amostras foram classificadas na classe/grupo 1
cont2=0; %conta quantas amostras foram classificadas na classe/grupo 2
cont3=0; %conta quantas amostras foram classificadas na classe/grupo 3
for i=1:a
    for j=1:b
      m_coord(i,j)=0; %matriz com mesmas dimenses de m (c X l) com o somatrio
                      %de cada coordenada 'l' para cada centroide 'c'.
    end
end
  for j=1:N
    if((Dist(1,j)<Dist(2,j))&&(Dist(1,j)<Dist(3,j)))
        Classe(1,j)=1;
        Classe(2,j)=0;
        Classe(3,j)=0;
        cont1=cont1+1;
        m_coord(1,1)=m_coord(1,1)+D(j,1);
        m_coord(1,2)=m_coord(1,2)+D(j,2);
        m_coord(1,3)=m_coord(1,3)+D(j,3);
    elseif((Dist(2,j)<Dist(1,j))&&(Dist(2,j)<Dist(3,j)))
        Classe(1,j)=0;
        Classe(2,j)=1;
        Classe(3,j)=0;
        cont2=cont2+1;
        m_coord(2,1)=m_coord(2,1)+D(j,1);
        m_coord(2,2)=m_coord(2,2)+D(j,2);
        m_coord(2,3)=m_coord(2,3)+D(j,3);
    else
        Classe(1,j)=0;
        Classe(2,j)=0;
        Classe(3,j)=1;
        cont3=cont3+1;
        m_coord(3,1)=m_coord(3,1)+D(j,1);
        m_coord(3,2)=m_coord(3,2)+D(j,2);
        m_coord(3,3)=m_coord(3,3)+D(j,3);
    end
 end
%clculo do novo centroide
    for k=1:3
        if(cont1>0)
    m(1,k)=m_coord(1,k)/cont1;
        end
        if(cont2>0)
    m(2,k)=m_coord(2,k)/cont2;
        end
        if(cont3>0)
    m(3,k)=m_coord(3,k)/cont3;
        end
    end
end
%Classificao dos pontos em suas classes/grupos de acordo com a distncia
%Euclidiana calculada do ponto a cada centroide.
%Tambm j  feito o clculo do novo centroide.
if(c==2) %se a quantidade de classes/grupos for 2
cont1=0; %conta quantas amostras foram classificadas na classe/grupo 1
cont2=0; %conta quantas amostras foram classificadas na classe/grupo 2
for i=1:a
    for j=1:b
      m_coord(i,j)=0; %matriz com mesmas dimenses de m (c X l) com o somatrio
                      %de cada coordenada 'l' para cada centroide 'c'.
    end
end
    for j=1:N
    if(Dist(1,j)<Dist(2,j))
        Classe(1,j)=1;
        Classe(2,j)=0;
        cont1=cont1+1;
        m_coord(1,1)=m_coord(1,1)+D(j,1);
        m_coord(1,2)=m_coord(1,2)+D(j,2);
        m_coord(1,3)=m_coord(1,3)+D(j,3);
    else
        Classe(1,j)=0;
        Classe(2,j)=1;
        cont2=cont2+1;
        m_coord(2,1)=m_coord(2,1)+D(j,1);
        m_coord(2,2)=m_coord(2,2)+D(j,2);
        m_coord(2,3)=m_coord(2,3)+D(j,3);
    end
    end
    %clculo do novo centroide
    for k=1:3
        if(cont1>0)
    m(1,k)=m_coord(1,k) / cont1;
        end
        if (cont2>0)
    m(2,k)=m_coord(2,k) / cont2;
        end
    end
end

if (iter == 1)
    class_temp=Classe;
end

if(iter > 1)
    for i=1:c
        for j=1:N
            if(Classe(i,j) == class_temp(i,j))
               dif= dif - 1; 
            end
        end
    end
    class_temp=Classe;
end
end
end
